<?php

namespace Drupal\custom_field\Plugin\CustomFieldType;

use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'float' customfield type.
 *
 * Note the class name needs to be FloatType as "Float" is a reserved class
 * name in php.
 *
 * @CustomFieldType(
 *   id = "float",
 *   label = @Translation("Float"),
 *   description = @Translation(""),
 *   category = @Translation("Number"),
 *   data_types = {
 *     "float",
 *   },
 * )
 */
class FloatType extends NumericBase {

  /**
   * {@inheritdoc}
   */
  public function widget(FieldItemListInterface $items, $delta, array $element, array &$form, FormStateInterface $form_state): array {
    // Get the base form element properties.
    $element = parent::widget($items, $delta, $element, $form, $form_state);

    // Add our widget type and additional properties and return.
    return [
      '#step' => 'any',
    ] + $element;
  }

  /**
   * {@inheritdoc}
   */
  public function widgetSettingsForm(array $form, FormStateInterface $form_state): array {
    $element = parent::widgetSettingsForm($form, $form_state);

    $element['settings']['min']['#scale'] = 'any';
    $element['settings']['max']['#scale'] = 'any';

    return $element;
  }

}
